package com.bonc.xcloud.sp_procedure.backend.interpreter.executors.xcloud;

import java.util.HashMap;
import org.apache.log4j.Logger;
import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.constantExpression.ConstantExpression;
import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.variableExpression.VariableExpression;

/**
 * Scope上下文元素
 */
public class ScopeContextItem {
	
	private static Logger logger = Logger.getLogger(ScopeContextItem.class);
	
	private HashMap<VariableExpression, ConstantExpression> varNameValueMap;//变量名对应变量值的map集合
	
	private ScopeContextItem(){
		varNameValueMap = new HashMap<VariableExpression, ConstantExpression>();
	}
	
	/**
	 * 创建Scope上下文元素实例
	 */
	public static ScopeContextItem newInstance(){
		return new ScopeContextItem();
	}
	
	/**
	 * 栈中加入一个变量及其值
	 */
	public boolean enterSingleVarValue(VariableExpression var, ConstantExpression value)throws Exception{
		
//		if(var == null || value == null){
//			logger.error("变量或值异常 ");
//			throw new Exception("变量或值异常 ");
//		}
//		if(varNameValueMap.get(var)!=null){
//			logger.error("变量 "+var.getVarName()+"已经存在");
//			throw new Exception("变量 "+var.getVarName()+"已经存在");
//		}
//		
//		//若var为形参,无需重新构造(批量入栈时已构造完毕)
//		if(DefinitionImpl.IN_PARM.equals(var.getAttribute(SyntaxTreeKeyImpl.DEFINITION))
//				|| DefinitionImpl.OUT_PARM.equals(var.getAttribute(SyntaxTreeKeyImpl.DEFINITION))
//				|| DefinitionImpl.IN_OUT_PARM.equals(var.getAttribute(SyntaxTreeKeyImpl.DEFINITION))){
//			varNameValueMap.put(var, value);
//		}
//		//若为普通变量,则需要重新构造,与中间值map中的值分开.
//		else{
//			
//			if(TypeChecker.isRecord(var.getTypeSpec())){
//				
//				varNameValueMap.put(var, value);
//				
//			}else{
//				ConstantExpression newValue = ExpressionFactory.createNoValueConstantExpression(var);
//				
//				//char/varchar要根据变量的声明长度设置值的长度
//				if(TypeChecker.isString(newValue.getTypeSpec())){
//					newValue.setLength(var.getLength());	
//				}
//				
//				//timestamp要根据变量的声明精度设置值的精度
//				if(TypeChecker.isTimestamp(newValue.getTypeSpec())){
//					((ConstantTimestampExpression)newValue).setM_fractional_seconds_precision(
//							((VariableTimestampExpression)var).getPrecision());
//				}
//				
//				if(TypeChecker.isIntervalDS(newValue.getTypeSpec())) {
//					((ConstantIntervalDSExpression)newValue).setM_days_precision(
//							((VariableIntervalDSExpression)var).getDayPrecision());
//					((ConstantIntervalDSExpression)newValue).setM_seconds_precision(
//							((VariableIntervalDSExpression)var).getSecondPrecision());
//				}
//				
//				if(TypeChecker.isIntervalYM(newValue.getTypeSpec())) {
//					((ConstantIntervalYMExpression)newValue).setM_years_precision(
//							((VariableIntervalYMExpression)var).getPrecision());
//				}
//				
//				
//				
//				
//				newValue.setConstValue(value.getConstValue());
//				varNameValueMap.put(var, newValue);
//			}
//			
//			
//		}
//		logger.debug("添加变量 " +var.getVarName()+"成功  : "+var.getVarName()+" = "+getVarValue(var).getConstValue());
		return true;
	}
	
	/**
	 * 修改var对应Constant的value值
	 */
	public boolean setVarValue(VariableExpression var, Object value)throws Exception{
		
//		if(var == null ){
//			logger.error("变量异常 ");
//			throw new Exception("变量异常 ");
//		}
//		
//		if(var instanceof VariableFieldExpression){
//			
//			VariableFieldExpression varField = (VariableFieldExpression)var;
//			VariableExpression var0 = varField.getVariableFieldsList().get(0);
//			VariableExpression var1 = varField.getVariableFieldsList().get(1);
//			
//			ConstantRecordExpression constantRecord;
//			
//			ConstantExpression constantValue = null;
//			
//			if(getVarValue(var0) == null){
//				logger.debug("变量 "+var.getVarName() +"不在本层" );
//				return false;
//			}
//			
//			for (int i = 0; i < varField.getVariableFieldsList().size()-1; i++) {
//				if(i==0){
//					constantRecord =(ConstantRecordExpression)
//					(varNameValueMap.get(var0));
//
//					constantValue = constantRecord.getmap_values().get(varField.getVariableFieldsList().get(1));
//				}else{
//					
//					constantRecord = (ConstantRecordExpression) constantValue;
//					constantValue = constantRecord.getmap_values().get(varField.getVariableFieldsList().get(i+1));
//					}
//			}
////			constantRecord =(ConstantRecordExpression)
////					(varNameValueMap.get(var0));
////			constantValue = 
////					constantRecord.getmap_values().get(var1);
////
//			constantValue.setConstValue(value);
//		}
//		else{
//			
//			if(getVarValue(var) == null){
//				logger.debug("变量 "+var.getVarName() +"不在本层" );
//				return false;
//			}
//			ConstantExpression varValue = varNameValueMap.get(var);
//			
//			varValue.setConstValue(value);
//		}
//			
//		logger.debug("修改变量 "+var.getVarName()+" 的值 成功: "
//				+var.getVarName()+" = "+value);
		return true;
	}
	
	/**
	 * 获取栈中变量的值
	 */
	public ConstantExpression getVarValue(VariableExpression var){
		
		/*if(var != null){
			ConstantExpression value = null;
			if(var instanceof VariableFieldExpression){
//				VariableFieldExpression varFiled = (VariableFieldExpression) var;
//				ConstantRecordExpression constantRecordExpression = (ConstantRecordExpression)getVarValue(varFiled.getVariableFieldsList().get(0));	
//				value = (constantRecordExpression.getmap_values()).get(varFiled.getVariableFieldsList().get(1));
				VariableFieldExpression varFiled = (VariableFieldExpression) var;
				ConstantRecordExpression constantRecordExpression = (ConstantRecordExpression)getVarValue(varFiled.getVariableFieldsList().get(0));	
				
				for (int j = 0; j < varFiled.getVariableFieldsList().size()-1; j++) {
					if(j==0){
						constantRecordExpression =(ConstantRecordExpression)getVarValue(varFiled.getVariableFieldsList().get(0));	
						value = constantRecordExpression.getmap_values().get(varFiled.getVariableFieldsList().get(1));
					}else{
						constantRecordExpression = (ConstantRecordExpression) value;
						value = constantRecordExpression.getmap_values().get(varFiled.getVariableFieldsList().get(j+1));
						}
				}
				
			}else{
				value = varNameValueMap.get(var);
			}
			
			 if(value != null){
				 logger.debug("获取变量 "+var.getVarName()+" 的值成功 : "+var.getVarName()+" = "+value.getConstValue());
				 return value;
			 }
//			 else{
//				 logger.error("获取变量 "+var.getVarName()+" 的值失败");
//				 return null;
//			 }
		}*/
		return null;
	}
	
	public HashMap<VariableExpression, ConstantExpression> getVarNameValueMap() {
		return varNameValueMap;
	}
}
