package com.bonc.xcloud.sp_procedure.frontend.xcloud;

//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.constantExpression.ConstantIntervalDSExpression;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.constantExpression.ConstantIntervalYMExpression;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.constantExpression.ConstantTimestampExpression;

public enum ParserErrorCode {
	// 0x130100 --- 0x130600
	//parser
	// 0x130100 --- 0x130600
	//parser
	ALREADY_FORWARDED(0x130100,"Already specified in FORWARD"),// 前面已经声明
    CASE_CONSTANT_REUSED(0x130101,"CASE constant reused"),// 实例常量重用
    IDENTIFIER_REDEFINED(0x130102,"Redefined identifier"),// 重定义的标识符
    IDENTIFIER_UNDEFINED(0x130103,"Undefined identifier"),// 未定义的标识符
    ASSIGN_ERROR(0x130104,"Assign error:in parameter can not be assigned"),//in参数不能被赋值
    LOOP_ERROR(0x130105,"Loop error:loop counter can not be assigned"),//for 计数器不能被赋值
    FUNCTION_UNDEFINED(0x130106,"Undefined function"),//未定义函数
    FUNCTION_ERROR(0x130107,"Function is Invalid"),//函数错误
    NOT_A_FUNCTION(0x130108,"Not a function"),//非函数
    NOT_A_PROCEDURE(0x130109,"Not a procedure"),//非过程
    PROCEDURE_UNDEFINED(0x13010a,"Undefined procedure"),//未定义过程
    PROCEDURE_ERROR(0x13010b,"Procedure is Invalid"),//过程错误
    INCOMPATIBLE_ASSIGNMENT(0x13010c,"Incompatible assignment"),// 不相容的赋值 
    INCOMPATIBLE_TYPES(0x13010d,"Incompatible types"),// 不相容的类型
    IS_NOT_A_WINDOW_FUNCTION(0x13010e,"Is not a window function"),// 不是窗口函数
    MUST_BE_A_RESULT_NOT_NULL(0x13010f,"must be a result not null"),//所有的thenExpression(包括elseExpression)至少有一个结果不为null
    INCOMPATIBLE_PARAMETER(0x130110,"Parameter error:in_out/out parameter should be a variable or loop counter/in parameter can not be assigned"),//参数异常,inout,out参数应该为一个变量或者计数器和in参数不能作赋值
    INVALID_ASSIGNMENT(0x130111,"Invalid assignment statement"),// 非法的赋值语句
    INVALID_CHARACTER(0x130112,"Invalid character"),// 非法字符
    INVALID_CONSTANT(0x130113,"Invalid constant"),// 非法常量
    INVALID_EXPONENT(0x130114,"Invalid exponent"),// 非法指数
    INVALID_EXPRESSION(0x130115,"Invalid expression"),// 非法表达式
    EXPRESSION_TYPE_ERROR(0x130116,"expression type error"),// 表达式类型错误
    INVALID_FIELD(0x130117,"Invalid field"),// 非法作用域 
    INVALID_FRACTION(0x130118,"Invalid fraction"),// 非法分数
    INVALID_IDENTIFIER_USAGE(0x130119,"Invalid identifier usage"),// 非法标识符使用
    INVALID_INDEX_TYPE(0x13011a,"Invalid index type"),// 非法指数类型
    INVALID_NUMBER(0x13011b,"Invalid number"),// 非法数字
    INVALID_STATEMENT(0x13011c,"Invalid statement"),// 非法语句
    INVALID_SUBRANGE_TYPE(0x13011d,"Invalid subrange type"),// 非法子类型
    INVALID_TARGET(0x13011e,"Invalid assignment target"),// 非法赋值
    INVALID_TYPE(0x13011f,"Invalid type"),// 非法类型
    INVALID_VAR_PARM(0x130120,"Invalid VAR parameter"),// 非法的VAR参数
    INVALID_DEFAULT_VALUE(0x130121,"Invalid default value"),//非法的默认值
    INVALID_ACTUAL_PARAMETER(0x130122,"Invalid actual parameter"),//非法实参
    INVALID_SQL_STATEMENT(0x130123,"Invalid Sql statement"),//无效的SQL语句
    MIN_GT_MAX(0x130124,"Min limit greater than max limit"),// 最小边界大于最大边界
    MISSING_BEGIN(0x130125,"Missing \"BEGIN\""),// 缺失 BEGIN
    MISSING_COLON(0x130126,"Missing \":\""),// 缺失 :
    MISSING_COLON_EQUALS(0x130127,"Missing \":=\""),// 缺失 :=
    MISSING_COMMA(0x130128,"Missing \",\""),// 缺失 ,
    MISSING_CONSTANT(0x130129,"Missing constant"),// 缺失常量
    MISSING_DO(0x13012a,"Missing \"DO\""),// 缺失 DO
    MISSING_LOOP(0x13012b,"Missing \"LOOP\""),// 缺失LOOP
    MISSING_DOT_DOT(0x13012c,"Missing \"..\""),// 缺失 ..
    MISSING_END(0x13012d,"Missing \"END\""),// 缺失 END
    MISSING_EQUALS(0x13012e,"Missing \"=\""),// 缺失 =
    MISSING_EXIT(0x13012f,"Missing \"EXIT\""),// 缺失EXIT
    MISSING_FOR_CONTROL(0x130130,"Invalid FOR control variable"),// 非法的FOR控制变量
    MISSING_FOR(0x130131,"Missing \"FOR\""),// 缺失 FOR
    MISSING_IDENTIFIER(0x130132,"Missing identifier"),// 缺失标识符
    MISSING_PROCEDURE_NAME(0x130133,"Missing procedure_name"), //缺失过程名称
    MISSING_AS_OR_IS(0x130134,"Missing \"as\" or \"is\""),//缺失as或is
    MISSING_RETURN(0x130135,"Missing \"return\""),
    MISSING_KEYWORD(0x130136,"Missing keyword"), //缺失关键字
    MISSING_DATATYPE(0x130137,"Missing datatype"), //缺失数据类型
    MISSING_IN(0x130138,"Missing \"in\""),// 缺失in
    MISSING_LEFT_BRACKET(0x130139,"Missing \"[\""),// 缺失 [
    MISSING_OF(0x13013a,"Missing \"OF\""),// 缺失 OF
    MISSING_WHEN(0x13013b,"Missing \"WHEN\""),// 缺失 when
    MISSING_WHEN_SEMICOLON(0x13013c,"Missing \"WHEN\" or \";\""),
    MISSING_WHILE(0x13013d,"Missing \"while\""),// 缺失 while
    MISSING_PERIOD(0x13013e,"Missing \".\""),// 缺失 .
    MISSING_PROGRAM(0x13013f,"Missing \"PROGRAM\""),// 缺失 PROGRAM
    MISSING_RIGHT_BRACKET(0x130140,"Missing \"]\""),// 缺失 ]
    MISSING_RIGHT_PAREN(0x130141,"Missing \")\""),// 缺失 )
    MISSING_NULL(0x130142,"Missing \"NULL\""),// 缺失 NULL 记录定义中的子域
    MISSING_DEFAULT(0x130143,"Missing \"DEFAULT\""),// 缺失 DEFAULT 记录定义中的子域
    NUMBER_OF_PARAMETERS_ERROR(0x130144,"Number of parameters error"),// 参数个数不对
    MISSING_LEFT_PAREN(0x130145,"Missing \"(\""),// 缺失 (
    MISSING_SEMICOLON(0x130146,"Missing \";\""),// 缺失 ;
    MISSING_DECLARE(0x130147,"Missing \"declare\""),//缺失declare
    OTHER_WORDS_WILL_BE_IGNORED(0x130148,"Other words will be ignored"),//其他单词将被忽略
    MISSING_THEN(0x130149,"Missing \"THEN\""),// 缺失 THEN
    MISSING_TO_DOWNTO(0x13014a,"Missing \"TO\" or \"DOWNTO\""),// 缺失 TO 或者 DOWNTO
    MISSING_UNTIL(0x13014b,"Missing \"UNTIL\""),// 缺失 UNTIL
    MISSING_IF(0x13014c,"Missing \"IF\""),// 缺失 UNTIL
    MISSING_VARIABLE(0x13014d,"Missing variable"),// 缺失变量
    MISSING_FORMAL_PARAMETER(0x13014e,"Missing formal parameter"),// 缺失变量
    MISSING_LENGTH(0x13014f,"Missing length"),// 缺失长度
    MISSING_ENGINE(0x130150,"Missing_engine"),//缺失engine
    
    MISSING_TYPE(0x130151,"Missing_type"),//缺失type
    MISSING_IS(0x130152,"Missing_is"),//缺失is
    MISSING_RECORD(0x130153,"Missing_record"),//缺失record
    
    
    NOT_CONSTANT_IDENTIFIER(0x130154,"Not a constant identifier"),// 不是一个常量标识符
    NOT_RECORD_VARIABLE(0x130155,"Not a record variable"),// 不是一个记录变量
    NOT_TYPE_IDENTIFIER(0x130156,"Not a type identifier"),// 不是一个类型标识符
    RANGE_INTEGER(0x130157,"Integer literal out of range"),// 超出整型最大边界
    RANGE_LONG(0x130158,"Long literal out of range"),// 超出整型最大边界
    RANGE_REAL(0x130159,"Double literal out of range"),// 超出实数最大边界
    STACK_OVERFLOW(0x13015a,"Stack overflow"),// 栈溢出
    TOO_MANY_LEVELS(0x13015b,"Nesting level too deep"),// 嵌套层次太深
    TOO_MANY_SUBSCRIPTS(0x13015c,"Too many subscripts"),// 下标过多
    UNEXPECTED_EOF(0x13015d,"Unexpected end of file"),// 文件异常结束
    UNEXPECTED_TOKEN(0x13015e,"Unexpected token"),// 异常token
    UNIMPLEMENTED(0x13015f,"Unimplemented feature"),// 未实现的特征
    UNKNOWNSTRUCTURE(0x130160,"Unkown structure"),// 未知的结构
    UNSUPPORT_OPRATOR(0x130161,"Unsupport oprator"),//不支持的操作符
    WRONG_NUMBER_OF_PARMS(0x130162,"Wrong number of actual parameters"),// 实际参数错误数
    MISSING_OPERATION(0x130163,"Missing operation"), //确实操作信息
    NO_PROCEDURE(0x130164,"No procedure"),//没有此过程
    NO_FUNCTION(0x130165,"No function"),//没有此函数
    NO_ERRORCODD(0x130166,"No such errorCode"),//没有这个错误码
    MISSING_BY(0x130167,"Missing by"),// 缺失 by
    MISSING_FIRST_LAST(0x130168,"Missing first or last"),// 缺失 first 或者 last
    MISSING_PRECEDING(0x130169,"Missing preceding"),// 缺失 preceding
    MISSING_PRECEDING_OR_FOLLOWING(0x13016a,"Missing preceding or following"),// 缺失 preceding 或者following
    MISSING_ROW(0x13016b,"Missing row"),// 缺失 row
    MISSING_AND(0x13016c,"Missing and"),// 缺失 and
    MISSING_FOLLOWING(0x13016d,"Missing following"),// 缺失 following
    MISSING_INTO(0x13016e,"Missing into"),// 缺失 into
    MISSING_ON(0x13016f,"Missing on"),// 缺失on
    MISSING_TABLE(0x130170,"Missing table"),  //缺失table
    MISSING_PARTITION(0x130171,"Missing partition"), //缺失 PARTITION
    MISSING_FROM(0x130172,"Missing from"),//缺失 from
    MISSING_COL_NAME(0x130173,"Before this Missing col_name list"),// 缺失col_name
    MISSING_RIGHT_BRACE(0x130174,"Missing RIGHT_BRACE"),// 缺失}
    MISSING_SELECT(0x130175,"Missing SELECT"), //缺失select
    INVALID_COLUMN_NAME_OR_COLUMN_AMBIGUOUSLY_DEFINED(0x130176,"invalid column name or column ambiguously defined"),// 无效的列名或者列名含糊不清
    RETURN_STATEMENT_ERROR(0x130177,"Return statement should be in function"),//return语句应该在函数中
    NO_STATEMENT_BEFORE_END(0x130178,"no statement before end"),//end 之前没有语句
    PARSERERROR(0x130179,"Parser error"),//解析错误
    CHAR_VARCHAR_LENGTH_ERROR(0x13017a,"Char or Varchar Length is between 1 and "+StringToken.maxLength),
    TIMESTAMP_PRECISION_ERRPR(0x13017b,"Timestamp precision is between 0 and" +9),
    NOT_GENERATE_SYNTAXTREE(0x13017c,"Not generate syntaxtree"),//未生成语法树
    BEYOND_NAMED_LENGTH(0x13017d,"Beyond named length 30"),//超出命名长度
    // Fatal errors.
    IO_ERROR(0x13017e, "Object I/O error"),// IO 错误
    TOO_MANY_ERRORS(0x13017f, "Too many syntax errors"), 
    UNSUPPORTED_FUNCTION(0x130180,"unsupported function"),
    MISSING_CASE(0x130181,"missing CASE"),// 缺失case
	TABLE_IS_NOT_EXIST_IN_SCHEMA(0x130182,"Table is not exist in Schema"),// 表不在用户中
	COLUMN_IS_NOT_EXIST_IN_TABLE(0x130183,"column is not exist in table"),// 字段不在表中
	
	
	METADATA_SERVICE_ERROR(0x130184,"MetaData Service is Invalid"),//metaData服务异常
	
	INVALID_TIMETYPE(0x130185,"invalid timetype"),
	IMPROPER_USE_TABLE_ALIAS(0x130186,"Improper use table alias"),// 表别名使用不当
	IMPICIT_CUSOR_NAME_ERROR(0x130187,"Impicit Cusor Name Error"),//隐式游标名字错误   不是SQL却进入了隐式游标解析器
	IMPICIT_CUSOR_FORMAT_ERROR(0x130188,"Impicit Cusor Format Error"),//隐式游标格式错误		SQL后接的是不是%
	IMPICIT_CUSOR_ATTRIBUTE_NAME_ERROR(0x130189,"Impicit Cusor Attribute Name Error"),//隐式游标属性名错误
	NO_FIELD(0x13018a,"No_field"),//记录类型中没有这个域
	Get_MetaData_Exception(0x13018b,"MetaData Service is Invalid"),
	NO_COLUMN(0x13018c,"No column"),
	NO_TABLE(0x13018d,"No table"),
	MISSING_TYPE_OR_ROWTYPE(0x13018e,"missing type or rowtype"),
	INTERVALYM_PRECISION_ERROR(0x13018f,"intervalym precision is between 0 and"+9),
	INTERVALDS_PRECISION_ERROR(0x130190,"intervalds precision is between 0 and"+9),
	NO_CURSOR(0x130191,"No Cursor"),//没有此游标;
	ENGINE_NAME_Exception(0x130192,"Engine name is Invalid"),
	BOOLEAN_IN_OUT_NOT_SUPPORTED(0x130193,"boolean in out not supported"),
	SELECT_INTO_MULTIPLE_RECORD(0x130194,"coercion into multiple record targets is not supported"),
	UNSUITABLE_VALUE_COUNT(0x130195,"unsuitable value count"),
	UNDEFINED_CURSOR(0x130196,"Undefined cursor"),//未定义或声明此游标;
	CURSOR_ATTRIBUTE_NAME_ERROR(0x130197,"Cusor Attribute Name Error"),//游标属性名错误
	LOOPINDEX_USE_INVALID(0x130198,"loop index variable use is invalid"),
	IN_OUT_VARIABLE_CANNOT_BE_REFERENCED(0x130198,"in out variable variable cannot be referenced"),//循环索引变量使用无效

	INCONSISTENT_DATATYPES_INTERVAL(0x130199,"inconsistent datatypes:expected NUMBER got INTERVAL"),//interval 不能用负数表示，在语义部分检查
	INCONSISTENT_DATATYPES_DATE(0x13019a,"inconsistent datatypes:expected NUMBER got DATE"),//date 不能用负数表示，在语义部分检查
	INCONSISTENT_DATATYPES_TIMESTAMP(0x13019b,"inconsistent datatypes:expected NUMBER got TIMESTAMP WITH TIME ZONE"),//timestamp 不能用负数表示，在语义部分检查
	INVALID_IDENTIFIER(0x13019c,"invalid identifier");
    private int code;        //错误码
    private String message;  // error message

    
    private ParserErrorCode(int code, String message) {
		this.code = code;
		this.message = message;
	}

	/**
     * Constructor.
     * @param message the error message.
     */
//    ParserErrorCode(String message)
//    {
//    	this.code = 0x140000-5- this.ordinal();
//        this.message = message;
//    }
    
//    /**
//     * Constructor.
//     * @param status the exit status.
//     * @param message the error message.
//     */
//    ParserErrorCode(int status, String message)
//    {
//        this.status = status;
//        this.message = message;
//    }

//    /**
//     * Getter.
//     * @return the exit status.
//     */
//    public int getStatus()
//    {
//        return status;
//    }

    /**
     * @return the message.
     */
    public String toString()
    {
        return message;
    }
    
    public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}
	
	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public static void main(String[] args) {
    	
    	try{
    		System.out.println(0x134000);
    		
    	}catch(Exception e){
    	}
    	
    	
    	
    	
		
	}
    
}
