package com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl;

//import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.HashMap;
//import java.util.List;



import org.apache.log4j.Logger;
//
//import com.bonc.base.model.DBConfiguration;
//import com.bonc.exception.sp_procedureException;
import com.bonc.xcloud.sp_procedure.backend.interpreter.executors.xcloud.CallStack;
import com.bonc.xcloud.sp_procedure.backend.interpreter.executors.xcloud.FunctionCallContext;
//import com.bonc.xcloud.sp_procedure.backend.interpreter.executors.xcloud.RuntimeStatementPointer;
//import com.bonc.xcloud.sp_procedure.dispatch.ProcConfig;
import com.bonc.xcloud.sp_procedure.intermediate.syntax.ISyntaxTree;
import com.bonc.xcloud.sp_procedure.intermediate.syntax.ISyntaxTreeKey;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.sql.ITableItem;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.sql.SqlSemanticCheckException;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.Expression;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.constantExpression.ConstantExpression;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.expression.variableExpression.VariableExpression;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.statement.ExceptionStatement;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.statement.ExecutableBlockStatement;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.statement.FunctionDeclareStatement;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.statement.ProcedureDeclareStatement;
//import com.bonc.xcloud.sp_procedure.intermediate.syntax.syntaximpl.statement.Statement;
//import com.bonc.xcloud.sp_procedure.util.ExceptionUtil;

/**
 * 语法树
 */
public abstract class SyntaxTree extends HashMap implements ISyntaxTree{
	private static final long serialVersionUID = 1L;
	private Logger logger = Logger.getLogger(SyntaxTree.class);

	/**
	 * set属性
	 */
	public void setAttribute(ISyntaxTreeKey key, Object value) {
		
		put(key, value);
		
	}

	/**
	 * get属性
	 */
	public Object getAttribute(ISyntaxTreeKey key) {
		
		return get(key);
	}
	
	protected abstract Object stepExec(FunctionCallContext ctx,CallStack callStack)throws Exception;
	
	@Override
	public final Object stepExecute(FunctionCallContext ctx, CallStack callStack)throws Exception {
		
		Object obj = null;
		try{
			obj = stepExec(ctx,callStack);
		}catch(Exception e){

//			logger.debug(e.getMessage(),e);



//			logger.error("异常  == " + e.getMessage());

			exceptionHandle(ctx,callStack, e);
		}
		
		return obj;
	}
	
	/**
	 * 异常处理
	 */
	public void exceptionHandle(FunctionCallContext ctx, CallStack callStack,
			Exception e) throws Exception {
//		
//		ProcedureException procedureException = null;
//		
//		//异常包装成ProcedureException
//		if(!(e instanceof ProcedureException)){
//			
//			procedureException = ExceptionUtil.constructProcedureException(e);
//			//追加异常记录
//			if(this.getAttribute(SyntaxTreeKeyImpl.LINE)!=null && 
//					this.getAttribute(SyntaxTreeKeyImpl.POSITION)!=null){
//				ExceptionUtil.appendExceptionRecord(
//						procedureException, null, 
//						(Integer)this.getAttribute(SyntaxTreeKeyImpl.LINE), 
//						(Integer)this.getAttribute(SyntaxTreeKeyImpl.POSITION));
//			}
//		}else{
//			procedureException = (ProcedureException)e;
//		}
//		
//		//异常保存在ctx中
//		ctx.setException(procedureException);
//		
//		//如果为不可恢复异常,退出并调用父语句的退出
//		
//		while(true){
//			
//			Statement top = callStack.getTopStatement();
//			
//			if(top != null){
//				
//				//executable语句可能存在异常处理语句
//				if(top instanceof ExecutableBlockStatement){
//					
//					ExecutableBlockStatement exe = (ExecutableBlockStatement)top;
//					
//					//存在异常处理则执行异常处理语句
//					if(exe.getExceptionStatement()!=null){
//						RuntimeStatementPointer ptr = callStack.peek();
//						ptr.setCurrentIndex(2);
//						exe.stepExecute(ctx, callStack);
//						break;
//					}else{
//						top.exitStatementImmediately(ctx, callStack);
//					}
//				}
//				
//				//异常处理语句再出异常
//				else if(top instanceof ExceptionStatement){
//					top.exitStatementImmediately(ctx, callStack);
//					//需要pop掉上层的ExcuteableBlockStatement
//					top = callStack.getTopStatement();
//					top.exitStatementImmediately(ctx, callStack);
//				}
//				
//				//procedure加错误过程名称
//				else if(top instanceof ProcedureDeclareStatement){
//					
////					  procedureException = ExceptionUtil.constructProcedureException(e);
////						//追加异常记录
////							if(this.getAttribute(SyntaxTreeKeyImpl.LINE)!=null && 
////					this.getAttribute(SyntaxTreeKeyImpl.POSITION)!=null){
////						ExceptionUtil.appendExceptionRecord(
////						procedureException, null, 
////						(Integer)this.getAttribute(SyntaxTreeKeyImpl.LINE), 
////						(Integer)this.getAttribute(SyntaxTreeKeyImpl.POSITION));
////							}
//					 
////					procedureException.appendExceptionProcedureName(
////							((ProcedureDeclareStatement)top).getProcedureName());
//					
//					ExceptionUtil.appendProcNameException(procedureException,
//							((ProcedureDeclareStatement)top).getProcedureName());
//					
//					top.exitStatementImmediately(ctx, callStack);
//					
//					top = callStack.getTopStatement();
//					
//					//procedureCall加错误记录
//					if(top!=null){
//						if(top.getAttribute(SyntaxTreeKeyImpl.LINE)!=null && 
//								top.getAttribute(SyntaxTreeKeyImpl.POSITION)!=null){
////							procedureException.appendExceptionRecord(null, 
////									(Integer)top.getAttribute(SyntaxTreeKeyImpl.LINE), 
////									(Integer)top.getAttribute(SyntaxTreeKeyImpl.POSITION));
//							
//							ExceptionUtil.appendExceptionRecord(procedureException, 
//									null, 
//									(Integer)top.getAttribute(SyntaxTreeKeyImpl.LINE), 
//									(Integer)top.getAttribute(SyntaxTreeKeyImpl.POSITION)) ;
//						}
//						top.exitStatementImmediately(ctx, callStack);
//					}
//				}
//				
//				//function要找到functioncall并加错误记录
//				else if(top instanceof FunctionDeclareStatement){
//					
////					procedureException.appendExceptionProcedureName(
////							((FunctionDeclareStatement)top).getFunctionName());
//					
//					ExceptionUtil.appendProcNameException(procedureException,
//							((FunctionDeclareStatement)top).getFunctionName());
//					
//					top.exitStatementImmediately(ctx, callStack);
//					
//					//找到functioncall
//					Expression functionCall = (Expression)callStack.searchIntermediateValue(top);
//					
//					if(functionCall.getAttribute(SyntaxTreeKeyImpl.LINE)!=null && 
//							functionCall.getAttribute(SyntaxTreeKeyImpl.POSITION)!=null){
////						procedureException.appendExceptionRecord(null, 
////								(Integer)functionCall.getAttribute(SyntaxTreeKeyImpl.LINE), 
////								(Integer)functionCall.getAttribute(SyntaxTreeKeyImpl.POSITION));
//						
//						ExceptionUtil.appendExceptionRecord(procedureException,
//								null, 
//								(Integer)functionCall.getAttribute(SyntaxTreeKeyImpl.LINE),
//								(Integer)functionCall.getAttribute(SyntaxTreeKeyImpl.POSITION));
//					}
//					
////					top.exitStatementImmediately(ctx, callStack);
//					
//				}else{
//					top.exitStatementImmediately(ctx, callStack);
//				}
////				top.exceptionHandle(ctx, callStack, procedureException);
//			}else{
//				throw procedureException;
//			}
//		}
//		
	}
	
	
	
	
	
	
	
	
	
	
	
	/**
	 * 根据名称和行列号查找对应的varExpression对象
	 */
//	public VariableExpression findVarExpression(String varName, int row, int column){
//		
//		//为无子对象
//		if(this instanceof VariableExpression || this instanceof ConstantExpression){
//			if(this instanceof VariableExpression){
//				VariableExpression var = (VariableExpression)this;
//				if(checkVarExpression(var,varName,row,column)){
//					return var;
//				}
//			}
//		}else{
//			//存在子对象的
//			Field[] fields = getClass().getDeclaredFields();
//			
//			for(Field field : fields){
//				
//				//用反射得到属性对象
//				Object fieldObj = getFieldValueByName(field.getName(),this);
//				
//				if(fieldObj == null) continue;
//				
//				if(fieldObj instanceof List){//为list集合
//					
//					List listObjs = (List) fieldObj;
//					for(int i=0;i<listObjs.size();i++){
//						Object obj = listObjs.get(i);
//						if(obj instanceof SyntaxTree){
//							
//							if(fieldObj instanceof VariableExpression){//为Variable可直接检验是否为查找的那个
//								VariableExpression var = (VariableExpression)obj;
//								if(checkVarExpression(var,varName,row,column)){
//									return var;
//								}
//							}else{//不是Varialbe,继续调用子属性的getVarExpression方法
//								VariableExpression var =((SyntaxTree) obj).findVarExpression(varName, row, column);
//								if(var != null) return var;
//							}
//							
//						}else{//集合中对象不是SyntaxTree,直接退出对集合的遍历
//							break;
//						}
//					}
//				}
//				else if(fieldObj instanceof SyntaxTree){//为SynataxTree
//					
//					if(fieldObj instanceof VariableExpression){//为Variable可直接检验是否为查找的那个
//						VariableExpression var = (VariableExpression)fieldObj;
//						if(checkVarExpression(var,varName,row,column)){
//							return var;
//						}
//					}else{//不是Varialbe,继续调用子属性的getVarExpression方法
//						VariableExpression var =((SyntaxTree) fieldObj).findVarExpression(varName, row, column);
//						if(var != null) return var;
//					}
//				}
//			}
//		}
//		
//		
//		return null;
//	}
	
		/** 
		 * 根据属性名获取属性值 
		 * */  
	   private Object getFieldValueByName(String fieldName, SyntaxTree o) { 
		   
	       try {    
	           String firstLetter = fieldName.substring(0, 1).toUpperCase();    
	           String getter = "get" + firstLetter + fieldName.substring(1);
//	           logger.debug(getter);
	           Method method = o.getClass().getMethod(getter, new Class[] {});    
	           Object value = method.invoke(o, new Object[] {});
	           return value;    
	       } catch (Exception e) {    
//	    	   logger.error(e.getMessage(),e);  
	           return null;    
	       }    
	   }   
	
	   /**
	    * 检验var是否为所查找的
	    */
//	   public boolean checkVarExpression(VariableExpression var ,String varName, int row, int column){
//		   
//		   if(var.getVarName().equalsIgnoreCase(varName)){
//				if((Integer)var.getAttribute(SyntaxTreeKeyImpl.LINE) == row){
//					if((Integer)var.getAttribute(SyntaxTreeKeyImpl.POSITION) == column){
//						return true;
//					}
//				}
//			}
//		   return false;
//	   }

	
//	/**
//	 * 为子属性设置dbConfiguration属性,支持syntaxTree,List<SyntaxTree>
//	 * @param dbConfiguration
//	 */
//	public void setFieldsDbConfiguration(DBConfiguration dbConfiguration){
//		
//		//存在子对象的
//		Field[] fields = getClass().getDeclaredFields();
//		
//		
//		for(Field field : fields){
//			
//			Object fieldObj = getFieldValueByName(field.getName(),this);
//			
////			logger.debug(fieldObj==null?null:fieldObj.getClass());
//			
//			if(fieldObj == null) continue;
//			//子属性为list集合
//			if(fieldObj instanceof List){
//				List listFiled = (List)fieldObj;
//				for(int i=0;i<listFiled.size();i++){
////					logger.debug(fieldObj==null?null:fieldObj.getClass());
//					Object listItem = listFiled.get(i);
//					if(listItem instanceof SyntaxTree){
//						((SyntaxTree) listItem).setDbConfiguration(dbConfiguration);
//					}else{
//						break;
//					}
//				}
//			}else{//子属性为syntaxTree
//				if(fieldObj instanceof SyntaxTree){
////					logger.debug(fieldObj==null?null:fieldObj.getClass());
//					((SyntaxTree) fieldObj).setDbConfiguration(dbConfiguration);
//				}
//			}
//			
//		}
//		
//	}
	   
	   public String toSql(FunctionCallContext ctx){
		   return null;
	   }
	   
//	   public Object semanticCheck(DBConfiguration dbConfiguration,List<List<ITableItem>> list)throws SqlSemanticCheckException
//	   {
//		   return null;
//	   }
	
}
